<?php

/**
 * UserRepository.php - Repository file
 *
 * This file is part of the User component.
 *-----------------------------------------------------------------------------*/

namespace App\Yantrana\Components\User\Repositories;

use App\Yantrana\Base\BaseRepository;
use App\Yantrana\Components\Auth\Models\AuthModel;
use App\Yantrana\Components\User\Interfaces\UserRepositoryInterface;
use Illuminate\Support\Facades\Auth;

class UserRepository extends BaseRepository implements UserRepositoryInterface
{
    /**
     * primary model instance
     *
     * @var object
     */
    protected $primaryModel = AuthModel::class;

    public function updateLoggedInUserProfile($updateData)
    {
        $user = Auth::user();
        $dataToUpdate = [
            'first_name' => $updateData['first_name'],
            'last_name' => $updateData['last_name'],
        ];
        if ($user->email !== $updateData['email']) {
            $dataToUpdate['email'] = $updateData['email'];
            $dataToUpdate['email_verified_at'] = null;
        }

        return $this->updateIt($user, $dataToUpdate);
    }

    public function updateUserData($userData, $requireColumnsForUser)
    {
        // Check if page updated then return positive response
        if ($userData->modelUpdate($requireColumnsForUser)) {
            return true;
        }

        return false;
    }
}
