<?php

/**
 * VendorTransaction.php - Model file
 *
 * This file is part of the Vendor component.
 *-----------------------------------------------------------------------------*/

namespace App\Yantrana\Components\Vendor\Models;

use App\Yantrana\Base\BaseModel;

class VendorTransactionModel extends BaseModel
{
    /**
     * @var string - The database table used by the model.
     */
    protected $table = 'vendor_transactions';

    /**
     * @var array - The attributes that should be casted to native types.
     */
    protected $casts = [
        '__data' => 'array',
    ];

    /**
     * @var array - The attributes that are mass assignable.
     */
    protected $fillable = [];

    /**
     * Let the system knows Text columns treated as JSON
     *
     * @var array
     *----------------------------------------------------------------------- */
    protected $jsonColumns = [
        '__data' => [
            'payment_data_by' => 'string',
            'payment_raw_data' => 'array:extend',
        ],
    ];
}
