<!-- Page Heading -->
<h3><?= __tr('User Settings') ?></h3>
<!-- /Page Heading -->
<hr>
<!-- User Setting Form -->
<form class="lw-ajax-form lw-form" method="post" action="<?= route('manage.configuration.write', ['pageType' => request()->pageType]) ?>">
	<!-- Activation Required For New User -->
	<div class="form-group mt-2">
		<!-- Activation required for new user -->
		<label><?= __tr('Activation required for new Vendor') ?></label>
		<!-- /Activation required for new user -->
		<!-- Yes -->
		<div class="custom-control custom-radio custom-control-inline">
			<input type="radio" id="activation_required_yes" name="activation_required_for_new_user" class="custom-control-input" value="1" <?= $configurationData['activation_required_for_new_user'] == true ? 'checked' : '' ?>>
			<label class="custom-control-label" for="activation_required_yes"><?= __tr('Yes') ?></label>
		</div>
		<!-- /Yes -->
		<!-- No -->
		<div class="custom-control custom-radio custom-control-inline">
			<input type="radio" id="activation_required_no" name="activation_required_for_new_user" class="custom-control-input" value="0" <?= $configurationData['activation_required_for_new_user'] == false ? 'checked' : '' ?>>
			<label class="custom-control-label" for="activation_required_no"><?= __tr('No') ?></label>
		</div>
		<!-- /No -->
	</div>
	<!-- /Activation Required For New User -->
	{{-- User terms and conditions --}}
    <div class="form-group row">
		<!-- User Terms -->
		<div class="col-sm-12 mb-3 mb-sm-0">
			<label for="termsAndConditionsUrl"><?= __tr('User Terms And Conditions') ?></label>
			<textarea rows="10" name="user_terms" class="form-control form-control-user" id="termsAndConditionsUrl"><?= $configurationData['user_terms'] ?></textarea>
            <small class="form-text text-muted">{{  __tr('User needs to accept it while registering.') }}</small>
            <div class="my-3 text-muted">
                <small>{{ __tr('Public link : ') }} <a target="_blank" href="{{ route('app.terms_and_policies', [
                    'contentName' => 'user_terms'
                ]) }}">{{ route('app.terms_and_policies', [
                    'contentName' => 'user_terms'
                ]) }}</a></small>
            </div>
		</div>
		<!-- / User Terms -->
	</div>
    <div class="form-group row">
		<!-- Vendor Terms -->
		<div class="col-sm-12 mb-3 mb-sm-0">
			<label for="lwVendorTerms"><?= __tr('Vendor Terms And Conditions') ?></label>
			<textarea rows="10" name="vendor_terms" class="form-control form-control-user" id="lwVendorTerms"><?= $configurationData['vendor_terms'] ?></textarea>
            <small class="form-text text-muted">{{  __tr('Vendor needs to accept it while registering.') }}</small>
            <div class="my-3 text-muted">
                <small>{{ __tr('Public link : ') }} <a target="_blank" href="{{ route('app.terms_and_policies', [
                    'contentName' => 'vendor_terms'
                ]) }}">{{ route('app.terms_and_policies', [
                    'contentName' => 'vendor_terms'
                ]) }}</a></small>
            </div>
		</div>
		<!-- / Vendor Terms -->
	</div>
    <div class="form-group row">
		<!-- Privacy Policy Terms -->
		<div class="col-sm-12 mb-3 mb-sm-0">
			<label for="lwPrivacy PolicyTerms"><?= __tr('Privacy Policy') ?></label>
			<textarea rows="10" name="privacy_policy" class="form-control form-control-user" id="lwPrivacy PolicyTerms"><?= $configurationData['privacy_policy'] ?></textarea>
            <small class="form-text text-muted">{{  __tr('It will be your Privacy Policy') }}</small>
            <div class="my-3 text-muted">
                <small>{{ __tr('Public link : ') }} <a target="_blank" href="{{ route('app.terms_and_policies', [
                    'contentName' => 'privacy_policy'
                ]) }}">{{ route('app.terms_and_policies', [
                    'contentName' => 'privacy_policy'
                ]) }}</a></small>
            </div>
		</div>
		<!-- / Privacy Policy Terms -->
	</div>
	<!-- Update Button -->
	<a href class="lw-ajax-form-submit-action btn btn-primary btn-user lw-btn-block-mobile mt-2">
		<?= __tr('Save') ?>
	</a>
	<!-- /Update Button -->
</form>
<!-- /User Setting Form -->